package com.jiuqi.util;

package .tmp;

import com.jiuqi.util.RecIndex;

public class LinkComparable implements Comparable {
  private boolean _IsDescending;
  
  private Object _SelfValue;
  
  private Object _PriorityValue;
  
  public LinkComparable(Object selfValue) {
    this._SelfValue = selfValue;
  }
  
  public LinkComparable(Object priorityValue, Object selfValue) {
    this._PriorityValue = priorityValue;
    this._SelfValue = selfValue;
  }
  
  public boolean getIsDescending() {
    return this._IsDescending;
  }
  
  public void setIsDescending(boolean value) {
    this._IsDescending = value;
  }
  
  public int compareTo(Object o) {
    int result;
    if (o instanceof com.jiuqi.util.LinkComparable) {
      result = RecIndex.compare(this._PriorityValue, ((com.jiuqi.util.LinkComparable)o)._PriorityValue);
      if (result == 0) {
        result = RecIndex.compare(this._SelfValue, ((com.jiuqi.util.LinkComparable)o)._SelfValue);
        if (this._IsDescending)
          result = -result; 
      } 
    } else {
      result = RecIndex.compare(this._SelfValue, o);
    } 
    return result;
  }
  
  public static Object getSelfValue(Object o) {
    if (o instanceof com.jiuqi.util.LinkComparable)
      return ((com.jiuqi.util.LinkComparable)o)._SelfValue; 
    return o;
  }
  
  public static Object replaceSelfValue(Object o, Object _newSelfValue) {
    if (o instanceof com.jiuqi.util.LinkComparable) {
      ((com.jiuqi.util.LinkComparable)o)._SelfValue = _newSelfValue;
      return o;
    } 
    return _newSelfValue;
  }
}
